//          File: edge.cpp
//        Author: Fred Sisenda 
// Last modified: March 19, 2012

#include "edge.h"


// Constructor: creates undirected edge between v1 and v2 of weight w
Edge::Edge(int id, Vertex* v1, Vertex* v2, int w){
	index = id;
	weight = w;
	u = v1;
	v = v2;
}

// Default constructor
Edge::Edge(){
	index = 0;
	weight = 0;
	u = 0;
	v = 0;
}


// Returns vertex at one end of edge
Vertex* Edge::getEnd1(){
	return u;
}


// Returns vertex at other end of edge
Vertex* Edge::getEnd2(){
	return v;
}


// Returns the weight of edge n of this vertex
int Edge::getWeight(){
	return weight;
}

// Returns index of edge in graph
int Edge::getIndex(){
	return index;
}


