//          File: graph.h
//        Author: Fred Sisenda and Samuel Sandeen
// Last Modified: March 24, 2012

// Include guard
#ifndef __GRAPH_H_INCLUDED__
#define __GRAPH_H_INCLUDED__

#include <vector>
#include <iostream>
#include "vertex.h"
#include "edge.h"

// Forward declarations
class Edge;
class Vertex;

// Class definition
class Graph{
	std::vector<Vertex> V;
	std::vector<Edge> E;
	std::vector<Vertex*> vertices;
	std::vector<Vertex*> pseudo_map;
	std::vector<Edge*> edges;
	unsigned int numV;
	unsigned int numE;
public:
	Graph();
	Graph(unsigned int n);
	Vertex* getVertexById(unsigned int id);
	Vertex* getVertexByIndex(unsigned int n);
	Edge* getEdgeByIndex(unsigned int n);
	const std::vector<Edge*>& getEdges() const;
	unsigned int getNumVertices();
	unsigned int getNumEdges();
	bool addVertex(int id);
	bool addEdge(int v1Id, int v2Id, int w);
	void completeGraph();
	static void printEdges(Vertex* v);
	static void printEdge(Edge* e);
	void print();
};

#endif 