//          File: vertex.cpp
//        Author: Fred Sisenda 
// Last modified: March 19, 2012

#include <vector>
#include "vertex.h"

using namespace std;
	
// Constructor: creates a vertex with id
Vertex::Vertex(int initId, int ind){
	id = initId;
	index =ind;
	data = 0;
	numE = 0;
}


// Default Constructor
Vertex::Vertex(){
	id = 0;
	index = 0;
	data = 0;
	numE = 0;
}


// Returns the id of this vertex
int Vertex::getId(){
	return id;
}


// Returns the index of this vertex in graph
int Vertex::getIndex(){
	return index;
}


// Returns the number of edges adjacent to this vertex
int Vertex::getNumEdges(){
	return numE;
}


// Returns the destination vertex of edge n of this vertex
Vertex* Vertex::getEdgeDest(int n){
	return adjV[n];
}


// Returns the weight of edge n of this vertex
int Vertex::getEdgeWeight(int n){
	return adjW[n];
}


// Returns the edge obejct of edge n of this vertex
Edge* Vertex::getEdgeObj(int n){
	return adjE[n];
}


// Adds an edge of weight w from this vertex to dest vertex
void Vertex::addEdgeTo(Vertex* dest, int w, Edge* edge){
	numE++;
	adjV.push_back(dest);
	adjW.push_back(w);
	adjE.push_back(edge);
}

