//          File: vertex.h
//        Author: Fred Sisenda and Samuel Sandeen
// Last Modified: March 24, 2012

// Include guard
#ifndef __VERTEX_H_INCLUDED__
#define __VERTEX_H_INCLUDED__

// Forward declarations
class Edge;

// Class definition
class Vertex{
	int id, index;
	int numE;
	std::vector<Vertex*> adjV;
	std::vector<int> adjW;
	std::vector<Edge*> adjE;
	void addEdgeTo(Vertex* dest, int weight, Edge* edge);
	friend class Graph;
public:
	Vertex();
	Vertex(int id, int index);
	int data;	// public instance variable; might be useful ;-)
	int getId();
	int getIndex();
	int getNumEdges();
	Vertex* getEdgeDest(int n);
	int getEdgeWeight(int n);
	Edge* getEdgeObj(int n);	
};

#endif 